-- View: idm_rpt_cfg.idmrpt_user_events_v

DROP VIEW idm_rpt_cfg.idmrpt_user_events_v CASCADE;

CREATE OR REPLACE VIEW idm_rpt_cfg.idmrpt_user_events_v AS 
 SELECT event.event_id AS event_seq_no, event.event_name, event.rv40 AS event_id, event.event_datetime, idm_rpt_cfg.get_formatted_user_dn(event.init_user_domain, event.init_user_name) AS event_source_user, idm_rpt_cfg.get_formatted_user_dn(event.target_user_domain, event.target_user_name) AS event_destination_user, id.full_name AS event_target_user_name, event.base_message AS message, event.file_name, event.rv31, idv_driver.idv_name, idv_driver.idv_host, idv_driver.idv_id, idv_driver.rpt_drv_id, id.identity_id, id.first_name, id.last_name, id.middle_initial, id.full_name, id.job_title, id.department, id.location, id.email_address, id.identity_desc, event.rv43, event.xdas_taxonomy_id
   FROM idm_rpt_cfg.idmrpt_identity_v1 id
   INNER JOIN idm_rpt_cfg.idmrpt_idv_acct_all_v id_acct ON id.identity_id = id_acct.identity_id
   INNER JOIN idm_rpt_cfg.idmrpt_idv_v idv ON id_acct.idv_id = idv.idv_id
   INNER JOIN idm_rpt_cfg.idmrpt_rpt_driver_v idv_driver ON id_acct.rpt_drv_id = idv_driver.rpt_drv_id
   INNER JOIN events_rpt_v3 event ON ( 
	CASE
	    WHEN event.target_user_name IS NULL THEN 
			CASE
				WHEN event.init_user_name IS NULL THEN 
					id_acct.idv_acct_user = lower(event.init_user_id)
				ELSE 
					id_acct.idv_acct_user = lower(event.init_user_name)
			END
	    ELSE 
			CASE
				WHEN event.target_user_name LIKE '%cn=%o=%' THEN 
					lower(event.target_user_name) = lower(id_acct.idv_acct_dn)
				ELSE 
					CASE
						WHEN event.target_user_name = 'loginDisabled' OR event.target_user_name = 'Locked By Intruder' OR event.target_user_name LIKE 'Login Intruder%' THEN 
							id_acct.idv_acct_user = lower(event.init_user_name)
						ELSE 
							id_acct.idv_acct_user = lower(event.target_user_name)
					END
			END
	END AND 
	CASE
	    WHEN event.target_user_domain IS NULL THEN 
	    	id_acct.idv_acct_domain = lower(event.init_user_domain)
	    ELSE 
			CASE
				WHEN event.target_user_domain LIKE '%cn=%o=%' THEN 
					id_acct.idv_acct_dn = lower(event.target_user_domain)
				ELSE 
					id_acct.idv_acct_domain = lower(event.target_user_domain)
			END
	END);

ALTER TABLE idm_rpt_cfg.idmrpt_user_events_v
  OWNER TO idmrptsrv;
GRANT ALL ON TABLE idm_rpt_cfg.idmrpt_user_events_v TO idmrptsrv;
GRANT SELECT ON TABLE idm_rpt_cfg.idmrpt_user_events_v TO idmrptuser;